import { Traverse } from 'fs-tree-utils';
export declare type DeepFunc = Traverse.Options.DeepFunc;
export declare type SourceDetector = (x: Param) => boolean;
export declare type TargetSpecifier = (x: Param) => TargetList;
export declare type Param = Traverse.Options.DeepFunc.Param;
export declare type TargetList = ReadonlyArray<string>;
export declare type RequiredOptions = Readonly<Required<Options>>;
export interface Options {
    readonly deep?: DeepFunc;
    readonly isSource?: SourceDetector;
    readonly listTargets?: TargetSpecifier;
}
export declare namespace Clean {
    interface Result {
        readonly targets: Result.FileList;
        readonly reports: Result.ReportList;
        readonly success: Result.FileList;
        readonly failure: Result.FileList;
    }
    namespace Result {
        type FileList = ReadonlyArray<string>;
        type ReportList = ReadonlyArray<Report>;
        interface Report {
            readonly file: string;
            readonly deletion: Report.Deletion;
        }
        namespace Report {
            type Deletion = Deletion.Success | Deletion.Failure;
            namespace Deletion {
                interface Success {
                    readonly success: true;
                }
                interface Failure {
                    readonly success: false;
                    readonly error: any;
                }
            }
        }
    }
}
